package com.hzya.frame.ningboBankTreasury.dto.req;

/**
 * @Description 单笔转账请求参数
 * @Author xiangerlin
 * @Date 2024/7/26 16:27
 **/
public class SingleTransferReq {
    //客户号 必填
    private String custId;
    //付款账号 必填
    private String payAcc;
    //用途 必填，长度不能超过70
    private String purpose;
    //收款账号 必填
    private String rcvAcc;
    //收款方行名 和联行号二者必须填一个
    private String rcvBankName;
    //收款方联行号 对公支付必填
    private String rcvBankNo;
    //金额 必填
    private String amt;
    //同城异地标识 0同城 1异地
    private String areaSign;
    //单位代码 必填
    private String corpCode;
    //是否同行转账 0他行 1同行
    private String difBank;
    //交易流水号
    private String serialNo;
    //对公对私标识 0对公 1对丝
    private String isForIndividual;
    //是否预约支付 0非预约 1预约
    private String isSubscribe;
    //是否短信通知收款人 0不通知 1通知，只支持宁波银行付款的情况
    private String isTellRcv;
    //收款方手机号
    private String rcvMobile;
    //收款户名
    private String rcvName;
    //备注
    private String remark;
    //预约转账时间
    private String wishPayTime;
    //支付方式 0直接付款 1代理支付 2联动支付 3自动请款 ，为空时默认直接付款
    private String payType;
    //代理/联动账号/拨款账号
    private String remarkAcc;

    public String getCustId() {
        return custId;
    }

    public void setCustId(String custId) {
        this.custId = custId;
    }

    public String getPayAcc() {
        return payAcc;
    }

    public void setPayAcc(String payAcc) {
        this.payAcc = payAcc;
    }

    public String getPurpose() {
        return purpose;
    }

    public void setPurpose(String purpose) {
        this.purpose = purpose;
    }

    public String getRcvAcc() {
        return rcvAcc;
    }

    public void setRcvAcc(String rcvAcc) {
        this.rcvAcc = rcvAcc;
    }

    public String getRcvBankName() {
        return rcvBankName;
    }

    public void setRcvBankName(String rcvBankName) {
        this.rcvBankName = rcvBankName;
    }

    public String getRcvBankNo() {
        return rcvBankNo;
    }

    public void setRcvBankNo(String rcvBankNo) {
        this.rcvBankNo = rcvBankNo;
    }

    public String getAmt() {
        return amt;
    }

    public void setAmt(String amt) {
        this.amt = amt;
    }

    public String getAreaSign() {
        return areaSign;
    }

    public void setAreaSign(String areaSign) {
        this.areaSign = areaSign;
    }

    public String getCorpCode() {
        return corpCode;
    }

    public void setCorpCode(String corpCode) {
        this.corpCode = corpCode;
    }

    public String getDifBank() {
        return difBank;
    }

    public void setDifBank(String difBank) {
        this.difBank = difBank;
    }

    public String getSerialNo() {
        return serialNo;
    }

    public void setSerialNo(String serialNo) {
        this.serialNo = serialNo;
    }

    public String getIsForIndividual() {
        return isForIndividual;
    }

    public void setIsForIndividual(String isForIndividual) {
        this.isForIndividual = isForIndividual;
    }

    public String getIsSubscribe() {
        return isSubscribe;
    }

    public void setIsSubscribe(String isSubscribe) {
        this.isSubscribe = isSubscribe;
    }

    public String getIsTellRcv() {
        return isTellRcv;
    }

    public void setIsTellRcv(String isTellRcv) {
        this.isTellRcv = isTellRcv;
    }

    public String getRcvMobile() {
        return rcvMobile;
    }

    public void setRcvMobile(String rcvMobile) {
        this.rcvMobile = rcvMobile;
    }

    public String getRcvName() {
        return rcvName;
    }

    public void setRcvName(String rcvName) {
        this.rcvName = rcvName;
    }

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public String getWishPayTime() {
        return wishPayTime;
    }

    public void setWishPayTime(String wishPayTime) {
        this.wishPayTime = wishPayTime;
    }

    public String getPayType() {
        return payType;
    }

    public void setPayType(String payType) {
        this.payType = payType;
    }

    public String getRemarkAcc() {
        return remarkAcc;
    }

    public void setRemarkAcc(String remarkAcc) {
        this.remarkAcc = remarkAcc;
    }
}
