package com.hzya.frame.ningboBankTreasury.enums;

/**
 * @Description 币种枚举
 * @Author xiangerlin
 * @Date 2024/7/24 17:07
 **/
public enum CurrencyEnum {

    人民币("01","人民币","CNY"),
    美元("02","美元","USD"),
    澳元("03","澳元","AUD"),
    欧元("04","欧元","EUR"),
    日元("05","日元","JPY"),
    英镑("06","英镑","GBP"),
    港币("07","港币","HKD"),
    新加坡元("08","新加坡元","SGD"),
    加拿大元("09","加拿大元","CAD"),
    瑞士("10","瑞士","CHF"),
    泰铢("23","泰铢","THB"),
    新台币("92","新台币","TWD"),
    ALL("ALL","多币","ALL");

    private final String code;
    private final String name;
    //英文代码 CNY USD之类的
    private final String symbol;
    CurrencyEnum(String code,String name,String symbol) {
        this.code = code;
        this.name = name;
        this.symbol = symbol;
    }

    public String getName() {
        return name;
    }
    public String getCode() {
        return code;
    }

    public String getSymbol() {
        return symbol;
    }

    /**
     * 根据code获取币种名字
     * @param code
     * @return
     */
    public static String getNameByCode(String code){
        for (CurrencyEnum currency : values()) {
            if (currency.code.equals(code)) {
                return currency.name;
            }
        }
        return null; // 或者抛出异常，表示找不到对应的币种
    }

    /**
     * 根据code获取币种符号
     * @param code
     * @return
     */
    public static String getSymbolByCode(String code){
        for (CurrencyEnum currency : values()) {
            if (currency.code.equals(code)) {
                return currency.symbol;
            }
        }
        return null; // 或者抛出异常，表示找不到对应的币种
    }
}
