package com.hzya.frame.sysnew.grovy.service.impl;


import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.sysnew.application.entity.SysExtensionApiEntity;
import com.hzya.frame.sysnew.grovy.service.IGroovyIntegrationService;
import com.hzya.frame.util.GroovyUtil;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;

import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * Groovy 脚本执行实现类
 *
 * @author 👻👻👻👻👻👻👻👻👻👻 gjh
 * @version 1.0
 * @content
 * @date 2024-05-15 13:50
 */
@Service(value = "groovyIntegrationService")
public class GroovyIntegrationServiceImpl implements IGroovyIntegrationService {
    private static final Logger logger = LoggerFactory.getLogger(GroovyIntegrationServiceImpl.class);


    @Override
    public Object groovyScriptExecution(JSONObject jsonObject) {
        Object object = GroovyUtil.execute(jsonObject);
        return object;
    }

    public static void main(String[] args) {
        java.lang.String str = "{\"data\":{\"pk_areacl\":\"01\",\"document_rule\":\"KH-2024-08-02-00001\",\"create_user_id\":\"1\",\"code\":\"K202408010001\",\"create_time\":1722580487000,\"company_id\":\"Y\",\"modify_time\":1722580487000,\"document_rule_num\":1,\"mdm_customer_bank\":[],\"add_status\":\"0\",\"update_status\":\"1\",\"sts\":\"Y\",\"delete_status\":\"1\",\"org_id\":\"Y\",\"name\":\"测试手动下发\",\"id\":\"f0daa2ce563949968aeb2b4cfd7f4fad\",\"data_status\":\"Y\",\"modify_user_id\":\"1\",\"sorts\":136,\"custshortname\":\"测试手动下发\"},\"query\":\"[]\",\"header\":\"[{\\\"parameterType\\\":\\\"fundamental\\\",\\\"concreteType\\\":\\\"String\\\",\\\"index\\\":0,\\\"parameterName\\\":\\\"usercode\\\",\\\"id\\\":\\\"7e7c7f83-9cb1-491d-bd1a-d23744bacba8\\\",\\\"example\\\":\\\"17633965916\\\"},{\\\"parameterType\\\":\\\"fundamental\\\",\\\"concreteType\\\":\\\"String\\\",\\\"index\\\":1,\\\"parameterName\\\":\\\"password\\\",\\\"id\\\":\\\"e6c1a7c7-0bcc-4246-b62c-e2313b092438\\\",\\\"example\\\":\\\"92d40fd65a74377608c0039eaafdba99\\\"},{\\\"parameterType\\\":\\\"fundamental\\\",\\\"concreteType\\\":\\\"String\\\",\\\"index\\\":2,\\\"parameterName\\\":\\\"trantype\\\",\\\"id\\\":\\\"b4ff0ceb-d797-462a-8c93-124f5a053628\\\",\\\"example\\\":\\\"code\\\"},{\\\"parameterType\\\":\\\"fundamental\\\",\\\"concreteType\\\":\\\"String\\\",\\\"index\\\":3,\\\"parameterName\\\":\\\"system\\\",\\\"id\\\":\\\"a8962ee0-108f-427a-8862-8f8e5c8e61ab\\\",\\\"example\\\":\\\"01\\\"}]\",\"body\":\"[{\\\"parameterType\\\":\\\"complexlist\\\",\\\"children\\\":[{\\\"parameterType\\\":\\\"complexlist\\\",\\\"children\\\":[{\\\"parameterType\\\":\\\"fundamental\\\",\\\"concreteType\\\":\\\"String\\\",\\\"index\\\":2,\\\"parameterName\\\":\\\"accname\\\",\\\"id\\\":\\\"69014133-b81e-4a9d-82fc-7c29821e77f9\\\",\\\"example\\\":\\\"666601\\\"},{\\\"parameterType\\\":\\\"fundamental\\\",\\\"concreteType\\\":\\\"String\\\",\\\"index\\\":3,\\\"parameterName\\\":\\\"account\\\",\\\"id\\\":\\\"51980e53-c1dd-448a-bf36-d24fd817b1a5\\\",\\\"example\\\":\\\"test001\\\"},{\\\"parameterType\\\":\\\"fundamental\\\",\\\"concreteType\\\":\\\"String\\\",\\\"index\\\":4,\\\"parameterName\\\":\\\"accountname\\\",\\\"id\\\":\\\"97111e2d-8df9-4465-a241-e1969b032287\\\",\\\"example\\\":\\\"zy测试银行账户\\\"},{\\\"parameterType\\\":\\\"fundamental\\\",\\\"concreteType\\\":\\\"String\\\",\\\"index\\\":5,\\\"parameterName\\\":\\\"banktypename\\\",\\\"id\\\":\\\"176cd4c8-5228-4dd6-bee7-2101f09a16d3\\\",\\\"example\\\":\\\"6666\\\"},{\\\"parameterType\\\":\\\"fundamental\\\",\\\"concreteType\\\":\\\"String\\\",\\\"index\\\":6,\\\"parameterName\\\":\\\"defflag\\\",\\\"id\\\":\\\"8d833cbf-a396-41af-ba52-cb58b3aa5a74\\\",\\\"example\\\":\\\"Y\\\"},{\\\"parameterType\\\":\\\"fundamental\\\",\\\"concreteType\\\":\\\"String\\\",\\\"index\\\":7,\\\"parameterName\\\":\\\"pk_currtype\\\",\\\"id\\\":\\\"d80241ec-c9fb-480c-9e0a-bd1589595a20\\\",\\\"example\\\":\\\"CNY\\\"},{\\\"parameterType\\\":\\\"fundamental\\\",\\\"concreteType\\\":\\\"String\\\",\\\"index\\\":8,\\\"parameterName\\\":\\\"status\\\",\\\"id\\\":\\\"2c7d4b42-b26e-4aa9-a294-3b330e08cf70\\\",\\\"example\\\":\\\"2\\\"},{\\\"parameterType\\\":\\\"fundamental\\\",\\\"concreteType\\\":\\\"String\\\",\\\"index\\\":9,\\\"parameterName\\\":\\\"unitname\\\",\\\"id\\\":\\\"9e6a593f-e35f-456e-879a-41d3d63bb94b\\\",\\\"example\\\":\\\"测试001\\\"}],\\\"concreteType\\\":\\\"ObjectCom\\\",\\\"index\\\":1,\\\"parameterName\\\":\\\"banks\\\",\\\"id\\\":\\\"3815c339-d96b-40d6-a96c-81b8cf68be28\\\"},{\\\"parameterType\\\":\\\"complex\\\",\\\"children\\\":[{\\\"parameterType\\\":\\\"fundamental\\\",\\\"concreteType\\\":\\\"String\\\",\\\"index\\\":11,\\\"parameterName\\\":\\\"conaddr\\\",\\\"id\\\":\\\"b5990933-94e0-4015-9f53-2ce6fa9bc3da\\\",\\\"example\\\":\\\"测试33145411113\\\"},{\\\"parameterType\\\":\\\"fundamental\\\",\\\"concreteType\\\":\\\"String\\\",\\\"index\\\":12,\\\"parameterName\\\":\\\"creator\\\",\\\"id\\\":\\\"f0cce0b5-b5fa-4ea7-8f15-f1ac075eb7f1\\\",\\\"example\\\":\\\"0001F8100000000000PL\\\"},{\\\"parameterType\\\":\\\"fundamental\\\",\\\"concreteType\\\":\\\"String\\\",\\\"index\\\":13,\\\"parameterName\\\":\\\"custcode\\\",\\\"id\\\":\\\"853453c3-dad1-4155-998b-9d1c4b8e2acd\\\",\\\"example\\\":\\\"ceshi007\\\"},{\\\"parameterType\\\":\\\"fundamental\\\",\\\"concreteType\\\":\\\"String\\\",\\\"index\\\":14,\\\"parameterName\\\":\\\"custname\\\",\\\"id\\\":\\\"2b06423d-827a-465d-b829-42471733fa51\\\",\\\"example\\\":\\\"测试007\\\"},{\\\"parameterType\\\":\\\"fundamental\\\",\\\"concreteType\\\":\\\"String\\\",\\\"index\\\":15,\\\"parameterName\\\":\\\"custprop\\\",\\\"id\\\":\\\"c4277bcb-7d80-4c12-8508-935086e2c7df\\\",\\\"example\\\":\\\"0\\\"},{\\\"parameterType\\\":\\\"fundamental\\\",\\\"concreteType\\\":\\\"String\\\",\\\"index\\\":16,\\\"parameterName\\\":\\\"custshortname\\\",\\\"id\\\":\\\"6c02f4ec-618c-4973-babe-a0c81c179743\\\",\\\"example\\\":\\\"测试007\\\"},{\\\"parameterType\\\":\\\"fundamental\\\",\\\"concreteType\\\":\\\"String\\\",\\\"index\\\":17,\\\"parameterName\\\":\\\"freecustflag\\\",\\\"id\\\":\\\"48c1d795-4396-4189-8f22-9228b2424fce\\\",\\\"example\\\":\\\"N\\\"},{\\\"parameterType\\\":\\\"fundamental\\\",\\\"concreteType\\\":\\\"String\\\",\\\"index\\\":18,\\\"parameterName\\\":\\\"isconnflag\\\",\\\"id\\\":\\\"92be035c-eb7c-46be-a2c3-5e48ce18cf4f\\\",\\\"example\\\":\\\"N\\\"},{\\\"parameterType\\\":\\\"fundamental\\\",\\\"concreteType\\\":\\\"String\\\",\\\"index\\\":19,\\\"parameterName\\\":\\\"pk_areacl\\\",\\\"id\\\":\\\"8bc3d731-ab42-46d5-afc3-3227de0df96b\\\",\\\"example\\\":\\\"01\\\"}],\\\"concreteType\\\":\\\"Object\\\",\\\"index\\\":10,\\\"parameterName\\\":\\\"parentvo\\\",\\\"id\\\":\\\"627af933-4b7f-433b-beb5-f2a49b50cfaa\\\"}],\\\"concreteType\\\":\\\"ObjectCom\\\",\\\"index\\\":0,\\\"parameterName\\\":\\\"cbdocvo\\\",\\\"id\\\":\\\"33aac70c-d95a-475d-8f98-28925223f305\\\"}]\"}";
        A88772 s = new A88772();
        System.out.println(s.execute(str));

//        String str = "{\"data\":\"{\\\"msg\\\":\\\"转发成功\\\",\\\"type\\\":null,\\\"flag\\\":true,\\\"status\\\":\\\"200\\\",\\\"attribute\\\":{\\\"data\\\":\\\"[{\\\\\\\"parentvo\\\\\\\":{\\\\\\\"pk_corp\\\\\\\":\\\\\\\"0001\\\\\\\",\\\\\\\"invcode\\\\\\\":\\\\\\\"CS202408020001\\\\\\\",\\\\\\\"invname\\\\\\\":\\\\\\\"测试存货档案\\\\\\\",\\\\\\\"pk_invcl\\\\\\\":\\\\\\\"0001A110000000000RB3\\\\\\\",\\\\\\\"invclcode\\\\\\\":\\\\\\\"0901\\\\\\\",\\\\\\\"invclname\\\\\\\":\\\\\\\"测试二级-1-1-1\\\\\\\",\\\\\\\"pk_measdoc\\\\\\\":\\\\\\\"0001A110000000000J7T\\\\\\\",\\\\\\\"meascode\\\\\\\":\\\\\\\"BAO\\\\\\\",\\\\\\\"measname\\\\\\\":\\\\\\\"包\\\\\\\",\\\\\\\"pk_taxitems\\\\\\\":\\\\\\\"40040000000000000037\\\\\\\",\\\\\\\"taxitemscode\\\\\\\":\\\\\\\"1001\\\\\\\",\\\\\\\"taxitemsname\\\\\\\":\\\\\\\"水泥\\\\\\\",\\\\\\\"unitvolume\\\\\\\":\\\\\\\"0.00000000\\\\\\\",\\\\\\\"unitweight\\\\\\\":\\\\\\\"0.00000000\\\\\\\",\\\\\\\"laborflag\\\\\\\":false,\\\\\\\"discountflag\\\\\\\":false,\\\\\\\"setpartsflag\\\\\\\":false,\\\\\\\"asset\\\\\\\":false,\\\\\\\"iselectrans\\\\\\\":false,\\\\\\\"isretail\\\\\\\":false,\\\\\\\"assistunit\\\\\\\":true,\\\\\\\"autobalancemeas\\\\\\\":false,\\\\\\\"ismngstockbygrswt\\\\\\\":false,\\\\\\\"isstorebyconvert\\\\\\\":false,\\\\\\\"creator\\\\\\\":\\\\\\\"openapi\\\\\\\",\\\\\\\"createtime\\\\\\\":\\\\\\\"2024-08-02 10:38:10\\\\\\\",\\\\\\\"pk_invbasdoc\\\\\\\":\\\\\\\"0001A110000000000SZM\\\\\\\",\\\\\\\"dr\\\\\\\":\\\\\\\"0\\\\\\\"},\\\\\\\"childrenvo\\\\\\\":[]}]\\\",\\\"taskNumber\\\":\\\"202408020006\\\",\\\"status\\\":\\\"success\\\"}}\"}";
//        g_482610back t = new g_482610back();
//        System.out.println(t.execute(str));
    }


    static class A88772 {
        String execute(String jsonStr) {
            com.alibaba.fastjson.JSONObject returnObject = new com.alibaba.fastjson.JSONObject();
            com.alibaba.fastjson.JSONObject bodys = new com.alibaba.fastjson.JSONObject();
            com.alibaba.fastjson.JSONArray cbdocvo = new com.alibaba.fastjson.JSONArray();
            com.alibaba.fastjson.JSONObject main = new com.alibaba.fastjson.JSONObject();
            com.alibaba.fastjson.JSONObject parentvo = new com.alibaba.fastjson.JSONObject();
            com.alibaba.fastjson.JSONObject reqData = com.alibaba.fastjson.JSON.parseObject(jsonStr);
            com.alibaba.fastjson.JSONObject data = reqData.getJSONObject("data");
            parentvo.put("pk_areacl", data.getString("pk_areacl"));
            parentvo.put("custcode", data.getString("code"));
            parentvo.put("custshortname", data.getString("custshortname"));
            parentvo.put("custname", data.getString("name"));
            main.put("parentvo",parentvo);
            cbdocvo.add(main);
            bodys.put("cbdocvo",cbdocvo);
            returnObject.put("bodys",bodys.toJSONString());
            return returnObject.toJSONString();





        }
    }
    static class g_482610back {
        String execute(String jsonStr){
        com.alibaba.fastjson.JSONObject returnObject = new com.alibaba.fastjson.JSONObject();
        com.alibaba.fastjson.JSONObject resData = com.alibaba.fastjson.JSON.parseObject(jsonStr);
        if("200".equals(resData.getJSONObject("data").get("status"))){
            com.alibaba.fastjson.JSONObject reqData = resData.getJSONObject("data").getJSONObject("attribute");
            if(null !=reqData){
                com.alibaba.fastjson.JSONObject header = new com.alibaba.fastjson.JSONObject();
                if(null !=reqData.getString("status")&& !"".equals(reqData.getString("status"))){
                    com.alibaba.fastjson.JSONArray dataArr = com.alibaba.fastjson.JSON.parseArray(reqData.getString("data"));
                    com.alibaba.fastjson.JSONObject data = dataArr.getJSONObject(0);
                    com.alibaba.fastjson.JSONObject parentvo = data.getJSONObject("parentvo");
                    returnObject.put("success","true");
                    returnObject.put("tripartiteId",parentvo.getString("pk_invbasdoc"));
                }else{
                    returnObject.put("success","false");
                }
            }else{
                returnObject.put("success","false");
            }
        }else {
            returnObject.put("success","false");
        }
        return returnObject.toJSONString(); } }
    static class g_494689 {
        public static void main(String[] args) {
            String str = "{\"data\":{\"pk_areacl\":\"01\",\"document_rule\":\"KH-2024-08-02-00007\",\"create_user_id\":\"1\",\"code\":\"K202408010006\",\"create_time\":1722584236000,\"company_id\":\"Y\",\"modify_time\":1722584236000,\"document_rule_num\":7,\"mdm_customer_bank\":[],\"add_status\":\"0\",\"update_status\":\"1\",\"sts\":\"Y\",\"delete_status\":\"1\",\"org_id\":\"Y\",\"custstate\":\"测试自动分配03\",\"id\":\"d9ccd167d0ae4e3884f2b76c31a88a34\",\"data_status\":\"Y\",\"modify_user_id\":\"1\",\"sorts\":142,\"custshortname\":\"测试自动分配03\"},\"query\":\"[]\",\"header\":\"[{\\\"parameterType\\\":\\\"fundamental\\\",\\\"index\\\":0,\\\"concreteType\\\":\\\"String\\\",\\\"id\\\":\\\"8e704f6e-20a8-49f9-b10a-fd1a6090565a\\\",\\\"parameterName\\\":\\\"usercode\\\",\\\"required\\\":false,\\\"example\\\":\\\"17633965916\\\"},{\\\"parameterType\\\":\\\"fundamental\\\",\\\"index\\\":1,\\\"concreteType\\\":\\\"String\\\",\\\"id\\\":\\\"5ca85472-dc42-45d8-9be6-dedf20cb09d9\\\",\\\"parameterName\\\":\\\"password\\\",\\\"example\\\":\\\"92d40fd65a74377608c0039eaafdba99\\\"},{\\\"parameterType\\\":\\\"fundamental\\\",\\\"index\\\":2,\\\"concreteType\\\":\\\"String\\\",\\\"id\\\":\\\"d32b0dfd-2f06-4ee1-a56d-03882f9003d4\\\",\\\"parameterName\\\":\\\"trantype\\\",\\\"example\\\":\\\"code\\\"},{\\\"parameterType\\\":\\\"fundamental\\\",\\\"index\\\":3,\\\"concreteType\\\":\\\"String\\\",\\\"id\\\":\\\"1f48a05d-8f89-4bb2-b29a-e1a6eac7f5b7\\\",\\\"parameterName\\\":\\\"system\\\",\\\"example\\\":\\\"01\\\"}]\",\"body\":\"[{\\\"parameterType\\\":\\\"complexlist\\\",\\\"children\\\":[{\\\"parameterType\\\":\\\"fundamental\\\",\\\"concreteType\\\":\\\"String\\\",\\\"index\\\":1,\\\"parameterName\\\":\\\"pk_corp\\\",\\\"id\\\":\\\"33bc86ee-652c-4822-b6a8-dbd329a20779\\\",\\\"example\\\":\\\"1004\\\"},{\\\"parameterType\\\":\\\"fundamental\\\",\\\"concreteType\\\":\\\"String\\\",\\\"index\\\":2,\\\"parameterName\\\":\\\"custprop\\\",\\\"id\\\":\\\"b5d55712-b378-4dbd-b2ae-04bcb3d0fb2b\\\",\\\"example\\\":\\\"0\\\"},{\\\"parameterType\\\":\\\"fundamental\\\",\\\"concreteType\\\":\\\"String\\\",\\\"index\\\":3,\\\"parameterName\\\":\\\"pk_cubasdoc\\\",\\\"id\\\":\\\"0c4a5614-effb-4d88-83e2-e9cd0f33ea3a\\\",\\\"example\\\":\\\"0001F810000000000FE0\\\"}],\\\"concreteType\\\":\\\"ObjectCom\\\",\\\"index\\\":0,\\\"parameterName\\\":\\\"custbasvo\\\",\\\"id\\\":\\\"df932132-3a93-463c-aaa7-7393b0abfa80\\\"}]\"}";
            g_494689 s = new g_494689();
            System.out.println(s.execute(str));
        }
        String execute (String jsonStr){
        com.alibaba.fastjson.JSONObject returnObject = new com.alibaba.fastjson.JSONObject();
        com.alibaba.fastjson.JSONObject bodys = new com.alibaba.fastjson.JSONObject();
        com.alibaba.fastjson.JSONArray custbasvo = new com.alibaba.fastjson.JSONArray();
        com.alibaba.fastjson.JSONObject main = new com.alibaba.fastjson.JSONObject();
        com.alibaba.fastjson.JSONObject reqData = com.alibaba.fastjson.JSON.parseObject(jsonStr);
        com.alibaba.fastjson.JSONObject data = reqData.getJSONObject("data");
        main.put("pk_corp", "002");
        main.put("pk_cubasdoc", reqData.getString("tripartiteId"));
        main.put("custprop", "2");
        custbasvo.add(main);
        bodys.put("custbasvo",custbasvo);
        returnObject.put("bodys",bodys.toJSONString());
        return returnObject.toJSONString(); } }

}
